// C Source File
// Created 10/31/00; 1:29:43 PM

#define USE_INITS_PATCH
#define USE_GRAY_PATCH
#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File
unsigned char* plane1=0;
unsigned char* plane2=0;
int lvlSet=0,maxcol=100,x=0,y=2,cursor=0,add=-3,lvl=0,step=0,numE=10;
int scStart=0,scEnd=0,pos=0,curs=0;

#include "thepicts.h"

typedef struct {
	int type;
} blocktype;

blocktype** level = 0;

blocktype enemy[900] = {
};

typedef struct {
	char world[8];
} setString;

setString name[1] = {
	{""}
};

blocktype plSt[6] = {
	{0},{0},{0},{0},{0},{0}
};

blocktype curEnem[3] = {
	{0},{0},{0}
};

void InitName()
{
	char s[8]="        ";
	int i;
  for(i=0;i<=8;i++)
	  name[0].world[i]=s[i];
}

void setInitialVars()
{
	int i=0,j=0;
  x=0;
  y=2;
  cursor=0;
  add=-3;
  maxcol=100;
  lvlSet=0;
  lvl=0;
  step=0;
  numE=10;
  scStart=0;
  for(i=0;i<6;i++)
  	plSt[i].type=0;
  for(i=0;i<3;i++)
  	curEnem[i].type=0;
  scEnd=0;
  for(i=0;i<10;i++)
   {
    for(j=0;j<maxcol*3;j++)
    	level[i][j].type=0;
   }
  for(i=0;i<numE*90;i++)
  	enemy[i].type=0;
  InitName();
}

void clear()
{
	SetPlane(0);
	ClrScr();
	SetPlane(1);
	ClrScr();
}

int SetMapArray() {
    int i;
    if (!(level = (blocktype**)malloc(sizeof(blocktype*)*10))) return 0;
    if (!(level[0] = (blocktype*)malloc(sizeof(blocktype)*(maxcol*3)*10))) return 0;
    for (i=0;i<10;i++)
    	level[i] = level[0] + i*maxcol*3;
    return 1;
}

void DrawR(int x1,int y1,int x2,int y2)
{
	int i,j;
	for(j=0;j<2;j++)
		{
			SetPlane(j);
			for(i=y1;i<=y2;i++)
				DrawLine(x1,i,x2,i,0);
		}
	DrawClipRect(MakeWinRect(x1,y1,x2,y2),ScrRect,1);
}

void DrawGUI()
{
	DrawStr(1,3,"            1       2       3       4       5       6",1);
	DrawStr(1,93,"            7       8       9       X       Y       Z",1);
	lftlndtop(32,1);
	midlndtop(50,1);
	rhtlndtop(68,1);
	qbox(86,1);
	box(104,1);
	eraser(122,1);
	DrawLine(0,10,160,10,3);
	lftlndmid(32,91);
	midlndmid(50,91);
	rhtlndmid(68,91);
	lftlndbot(86,91);
	midlndbot(104,91);
	rhtlndbot(122,91);
	DrawLine(0,89,160,89,3);
	DrawLine(0,77,160,77,3);
	DrawStr(1,81,"F1: Options  F2: Special  (: <- Scrn.  ): -> Scrn",1);
}

#include "lvlEnemy.h"

void DrawStarter()
{
	if(plSt[lvl*2+1].type>0)
		{
			if(plSt[lvl*2].type>=lvlSet*20 && plSt[lvl*2].type<=lvlSet*20+20)
				smiley(plSt[lvl*2].type*8,plSt[lvl*2+1].type*8+add);
		}
}

void DrawLevel()
{
	int i,j,k=0,wx,wy;
	scStart=lvlSet*20+lvl*100;
	scEnd=lvlSet*20+lvl*100+20;
	for(i=2;i<10;i++)
		{
			for(j=scStart;j<scEnd;j++)
				{
					wx=k*8;
					wy=i*8+add;
					masker(wx,wy);
					switch(level[i][j].type)
						{
							case 1:
								bolt(wx,wy); break;
							case 3: 
								lftlndtop(wx,wy); break;
							case 4:
								midlndtop(wx,wy); break;
							case 5:
								rhtlndtop(wx,wy); break;
							case 6:
								qbox(wx,wy); break;
							case 7:
								box(wx,wy); break;
							case 8:
								eraser(wx,wy); break;
							case 9:
								lftlndmid(wx,wy); break;
							case 10:
								midlndmid(wx,wy); break;
							case 11:
								rhtlndmid(wx,wy); break;
							case 12:
								lftlndbot(wx,wy); break;
							case 13:
								midlndbot(wx,wy); break;
							case 14:
								rhtlndbot(wx,wy); break;
							case 15:
								endPiece(wx,wy); break;
							case 16:
								qbox(wx,wy); break;
						}
					k++;
				}
			k=0;
		}
	DrawEnemy();
	DrawStarter();
}

void DrawCurrent()
{
	int wy,wx;
	DrawLevel();
	wx=x*8;
	wy=y*8+add;
	switch(cursor)
		{
			case 1:
				bolt(wx,wy); break;
			case 3: 
				lftlndtop(wx,wy); break;
			case 4:
				midlndtop(wx,wy); break;
			case 5:
				rhtlndtop(wx,wy); break;
			case 6:
				qbox(wx,wy); break;
			case 7:
				box(wx,wy); break;
			case 8:
				eraser(wx,wy); break;
			case 9:
				lftlndmid(wx,wy); break;
			case 10:
				midlndmid(wx,wy); break;
			case 11:
				rhtlndmid(wx,wy); break;
			case 12:
				lftlndbot(wx,wy); break;
			case 13:
				midlndbot(wx,wy); break;
			case 14:
				rhtlndbot(wx,wy); break;
			case 15:
				endPiece(wx,wy); break;
			case 16:
				smiley(wx,wy); break;
			case 17:
				oneDirEnemy(wx,wy); break;
			case 18:
				twoDirEnemy(wx,wy); break;
			case 19:
				flyingEnemy(wx,wy); break;
		}
}

#include "lvlSave.h"

void deletePLStart()
{
	if(x==plSt[lvl*2].type && y==plSt[lvl*2+1].type)
		{
			plSt[lvl*2].type=0;
			plSt[lvl*2+1].type=0;
		}
}

void setQBox()
{
	int key=0;
	DrawStr(1,81,"Do you want 1. a bolt or 2. a life to pop out?   ",A_REPLACE);
	while(key!=49 && key!=50)
		key=ngetchx();
	if(key==50)
		cursor=16;
	clear();
	DrawGUI();
}

void setter()
{
	level[y][x+scStart].type=cursor;
}

void setPos()
{
	if(step!=0)
			enemySet();
	else
		{
			if(cursor==8) cursor=0;
			if(cursor==0)
				{
					deleteEnemy();
					deletePLStart();
				}
			if(cursor<16)
				setter();
			else if(cursor==16)
				{
					plSt[lvl*2].type=x;
					plSt[lvl*2+1].type=y;
				}
			if(cursor==6)
				{
					setQBox();
					setter();
				}
		}		
	if(y>=4)
		y=y-2;
	else
		y=2;
	DrawLevel();
}

#include "menus.h"

void mainLoop()
{
	int key=0;
	DrawCurrent();
	while(key!=264)
		{
			pos=curEnem[lvl].type*numE+lvl*31*numE;
			if(key>=49 && key<=57)
				cursor=key-46;
			if(key>=120 && key<=122)
				cursor=key-108;
			if(key==268)
				options();
			if(key==269)
				special();
			if(key==340 && y!=9)
				y++;
			if(key==337 && y!=2)
				y--;
			if(key==344 && x!=19)
				x++;
			if(key==338 && x!=0)
				x--;
			if(key==40 && lvlSet!=0)
				{
					x=10;
					lvlSet--;
					DrawLevel();
				}
			if(key==41 && lvlSet!=4)
				{
					x=10;
					lvlSet++;
					DrawLevel();
				}
			if(cursor<17)
				step=0;
			if(key==13)
				setPos();
			if(cursor>0)
				DrawCurrent();
			key=ngetchx();
		}
}

void freeMem()
{
	if(level[0]!=NULL) free(level[0]);
	if(level!=NULL)
		{
			free(level);
			level=NULL;
		}
}

void _main(void)
{
	GrayMode(GRAY_ON);
	plane1 = GetPlane(0);
  plane2 = GetPlane(1);
  FontSetSys(F_4x6);
  clear();
  DrawGUI();
  SetMapArray();
	setInitialVars();
  mainLoop();
  freeMem();
  GrayMode(GRAY_OFF);
	return;
}
